/*
 * Segment 5 Intelligente Analyseverfahren, SWE 5.5 Funktionen Ganglinie
 * Copyright (C) 2011-2015 BitCtrl Systems GmbH
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.iav.gllib.gllib.domain.comm;

import java.time.Duration;
import java.util.List;
import java.util.concurrent.TimeoutException;
import java.util.function.Consumer;

/**
 * Schnittstelle für einen Client zur Abfrage von Ganglinienprognose über eine
 * Anfrage-/Antwort-Schnittstelle.
 * 
 * @author BitCtrl Systems GmbH, Uwe Peuker
 */
public interface GanglinienPrognoseClient {

    default void sendeAnfrage(List<PrognoseAnfrage> anfragen, Consumer<GlProgAntwort> antwortEmpfangen) {
        sendeAnfrage(null, anfragen, antwortEmpfangen);
    }

    void sendeAnfrage(String kennung, List<PrognoseAnfrage> anfragen, Consumer<GlProgAntwort> antwortEmpfangen);

    default void sendeAnfrage(List<PrognoseAnfrage> anfragen, Consumer<GlProgAntwort> antwortEmpfangen,
            Duration timeout, Runnable timeoutErreicht) {
        sendeAnfrage(null, anfragen, antwortEmpfangen, timeout, timeoutErreicht);
    }

    void sendeAnfrage(String kennung, List<PrognoseAnfrage> anfragen, Consumer<GlProgAntwort> antwortEmpfangen,
            Duration timeout, Runnable timeoutErreicht);

    default GlProgAntwort sendeAnfrage(List<PrognoseAnfrage> anfragen, Duration timeout) throws TimeoutException {
        return sendeAnfrage(null, anfragen, timeout);
    }

    GlProgAntwort sendeAnfrage(String kennung, List<PrognoseAnfrage> anfragen, Duration timeout)
            throws TimeoutException;
}
